/* Prompt windows */

#ifndef _Ipw
#define _Ipw 1

#include "bw.h"

typedef struct pw PW;

struct pw
{
	int (*pfunc)();           /* Func which gets called when RTN is hit */
	int (*abrt)();            /* Func which gets called when window is aborted */
	int (*tab)();             /* Func which gets called when TAB is hit */
	char *prompt;             /* Prompt string */
	int promptlen;            /* Width of prompt string */
	int promptofst;           /* Prompt scroll offset */
	B *hist;                  /* History buffer */
	void *object;             /* Object */
};

#define TYPEPW 0x200

/* BW *wmkpw(BW *bw,char *prompt,int (*func)(),char *huh,int (*abrt)(),
 *                               int (*tab)(),void *object,int *notify);
 * Create a prompt window for the given window
 */
BW *wmkpw();

int ucmplt();

#endif
