/* Query windows */

#ifndef _Iquery
#define _Iquery 1

#include "w.h"

typedef struct query QW;

struct query
{
	W *parent;                /* Window we're in */
	int (*func)();            /* Func. which gets called when key is hit */
	int (*abrt)();
	void *object;
	char *prompt;             /* Prompt string */
	int promptlen;            /* Width of prompt string */
	int promptofst;           /* Prompt scroll offset */
};

#define TYPEQW 0x1000

/* QW *mkqw(BW *bw,char *prompt,int (*func)(),int (*abrt)(),void *object);
 * Create a query window for the given window
 */
QW *mkqw();
QW *mkqwna();
QW *mkqwnsr();

#endif
